# CyclicSemiring< n > Struct Template Reference
[Algebra, Semiring]

Structural element that denotes tropical semiring. More...

Inheritance diagram for CyclicSemiring< n >:
[legend]

List of all members.

## Public Types

typedef CyclicSemiring< n > | self_t
| Exact type of the most derived type in the hierarchy.

## Public Member Functions

bool | can_choose_non_starable (SELECTOR(T)) const
| Whether it is possible to call choose_non_starable.
Element< CyclicSemiring< n >, T > | choose_starable (SELECTOR(T)) const
| A randomly chosen starable semiring element.
Element< CyclicSemiring< n >, T > | choose_non_starable (SELECTOR(T)) const
| A randomly chosen non-starable semiring element.
Element< CyclicSemiring< n >, T > | identity (SELECTOR(T)) const
| Returns the identity of the monoid (if mul_kind).
Element< CyclicSemiring< n >, T > | zero (SELECTOR(T)) const
| Returns the zero of the monoid (if add_kind).
bool | contains (const Element< CyclicSemiring< n >, T > &elt) const
| Check if a given element is compatible with the structural element.
bool | contains (const Element< OtherS, T > &other) const
| Specialization of `contains` that always returns false.
bool | contains (const T &elt_value) const
| Check if an anonymous value is compatible with a structural element.
Element< CyclicSemiring< n >, T > | choose (SELECTOR(T)) const
| Choose randomly an element in the structure.
self_t & | self ()
| Accessor to the real type.
const self_t & | self () const
| Accessor to the real type.

## Detailed Description

### template<unsigned int n>
struct vcsn::algebra::CyclicSemiring< n >

Structural element that denotes tropical semiring.

Definition at line 66 of file concept/cyclic_semiring.hh.

## Member Function Documentation

bool can_choose_non_starable | ( | SELECTOR(T) |  | ) | const`[inherited]`

Whether it is possible to call choose_non_starable.

There's no need for can_choose_starable, since Zero is always starable and therefore can be chosen.

bool contains | ( | const Element< OtherS, T > & | other | ) | const`[inherited]`

Specialization of `contains` that always returns false.

Indeed, elements structured by a particular type are always incompatible with structural elements of another type.

self_t& self | ( |  | ) | `[inherited]`

Accessor to the real type.

To be used by implementations in this class and derived structures to obtain a reference to the structural element with its most derived type.

const self_t& self | ( |  | ) | const`[inherited]`

Accessor to the real type.

To be used by implementations in this class and derived structures to obtain a reference to the structural element with its most derived type.